CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  'input pin list

  DMXPin = 27

  NumDMXChannels = 42         'Number of Channels being received (6 lights *7 channels = 42)

  'NumOfBuffers = 2           ' Don't forget to add a matching buffer to the VAR and modify the function writeToCurrentBuffer

OBJ
      
  'Comm : "FullDuplexSerial"
  'Comm : "Extended_FDSerial"
  'Comm : "JDCogSerial"
  Comm : "pcFullDuplexSerial4FC"
  NUM  : "Numbers"
  STR    : "STRINGS"
  DMXout : "DMXout"

VAR
  byte DMXBuffer1[NumDMXChannels+1]  '+1 is for the start byte
  byte DMXBuffer2[NumDMXChannels+1]

  'byte DMXBuffer1[15]           '43 = 6 lights * 7 channels + 1 start byte
  'byte DMXBuffer2[15]


  byte counter
  long recByte
  byte numChannelsSent
  byte bufferBeingFilled

  byte index

         
PUB Main

 {{
   -------------------------------
   Assumes data arrives in this fassion:
   NumOfChannels, ch1 Value, ch2 Value, ... chNumOfChannels Value <<END when counter == NumOfChannels>>
   
 }} 
  'Comm.start(RxPin, TxPin, BaudRate)
  'Comm.start(31,30, 230400)
  'Comm.start(31,30, 0, 57600)
  Comm.AddPort(0,31,30,-1,-1,0,0,57600)
  Comm.Start

  DMXout.Start(DMXPin,@DMXBuffer2)

  'Buttons.start 

  'NUM.Init

  counter := $00
  numChannelsSent := $ff '----Assume that we've sent the max amount of channels, then read the first byte and modify
  bufferBeingFilled := 1 '----Start with buffer 1
  
  repeat                    
  
     
     recByte := Comm.RxCheck(0)
     if(recByte <> -1)  'received a byte
          if (counter == numChannelsSent) '----Check if it's the last byte
                                '////Switch the Buffers
                                'Comm.str(string("last byte",10))
                   writeIntoCurrentBuffer(counter, recByte)
                   writeIntoCurrentBuffer(0, $00)

                   'lastButtonsPressed := Buttons.getLastCommandStringAddress
                   'Comm.str(Buttons.getLastCommandStringAddress)

                    
                    '========= debug, send strings
                   {{repeat index from 0 to numChannelsSent
                       
                       Comm.str(STR.Combine(Num.ToStr(counter,NUM#DEC),string(" ",46)))
                       Comm.str(STR.Combine(Num.ToStr(getValueOfCurrentBuffer(index),NUM#DEC),string(" ",46)))
                                                                                             
                   Comm.str(STR.Combine(Num.ToStr(bufferBeingFilled,NUM#DEC),string(" ",10))) }} 

                   if(bufferBeingFilled == 1)
                                DMXout.swapBuffer(@DMXBuffer1)
                                bufferBeingFilled := 2
                                'bytefill(@DMXBuffer2,0,NumDMXChannels+1)
                   else
                                DMXout.swapBuffer(@DMXBuffer2)
                                bufferBeingFilled := 1
                                'bytefill(@DMXBuffer1,0,NumDMXChannels+1)

                   counter := 0

                   
          elseif (counter > 0 AND counter < NumDMXChannels+1)          '----Check if it's a data byte

                   writeIntoCurrentBuffer(counter, recByte)
                   counter++
                   'Comm.str(string("write into buffer",10))

          else        '----- By process of elimination counter is equal to zero and it's the first byte
                  numChannelsSent := recByte
                  counter++
                  'Comm.str(string("received",10))
             
PRI AppendChar( dstStrPtr, char )
  dstStrPtr += StrSize(dstStrPtr)
  byte[ dstStrPtr++ ] := char
  byte[ dstStrPtr   ] := 0
                           
PRI writeIntoCurrentBuffer(atIndex, withByte)

    if (bufferBeingFilled == 1)
        DMXBuffer1[atIndex] := withByte
    elseif (bufferBeingFilled == 2)
        DMXBuffer2[atIndex] := withByte

PRI getValueOfCurrentBuffer(atIndex) : requestedByte
    if (bufferBeingFilled == 1)
        requestedByte := DMXBuffer1[atIndex]
    elseif (bufferBeingFilled == 2)
        requestedByte := DMXBuffer2[atIndex]


